/**************************/
/* file.h                 */
/**************************/
/* Fichier d'en tte pour */
/* la LibB - Barbux       */
/**************************/
/* Attention! Ne peut pas */
/* tre excut sous      */
/* Linux                  */
/**************************/

#ifndef __FILE__H__
#define __FILE__H__

/* Ce fichier d'en tte gre les appels systmes relatifs  la gestion de fichiers */


/********************************/
/* Dfinitions                  */
/********************************/
// Dfinitions de montage pour mount
#define MOUNT 0
#define UMOUNT 1

// Dfinitions des codes d'erreur pour open
#define ERR_NODISK -1 // Pas de disquette
#define ERR_NOFAT -2 // Disquette non Fat12
#define ERR_FNOF -3 // Fichier non trouv
#define ERR_FLIMIT -4 // Trop de fichiers ouverts
#define ERR_INVFILE -5 // Nom de fichier invalide

// Dfinitions pour le mode pour seek
#define FROM_BEG 1 // Du dbut
#define FROM_CUR 2 // De la position courante
#define FROM_EBD 3 // De la fin


/*******************************/
/* Structures                  */
/*******************************/
typedef struct heure
{
  char heures;
  char minutes;
  char secondes;
} heure;

typedef struct date
{
  char jour;
  char mois;
  int annee;
} date;

typedef struct fichier12
{
  char lfn;
  char nom[255];
  char ext[4];
  heure heuremodif;
  date datemodif;
  date dernieraccess;
  heure heurecreation;
  date datecreation;
  int taille;
  unsigned char attributs;
  unsigned short cluster;
} fichier12;



/*******************************/
/* Appels systme              */
/*******************************/

// Permet de monter ou dmonter la disquette
int mount(int mnt); // Appel systme n10

// Ouvre un fichier
int openf(char * file); // Appel systme n11

// Lit au plus nb octets  partir de la position courante
int readf(int fd, char * data, int nb); // Appel systme n12

// Ecrit nb octets  partir de la position courante
int writef(int fd, char * data, int nb); // Appel systme n13

// Dplace le fichier
int seek(int fd, int depl, int mode); // Appel systme n14

// Ferme le fichier
int closef(int fd); // Appel systme n15

// Cr un pipe
int pipe(int uid); // Appel systme n16



#endif
