// En dfinissant STRICT, on peut outrepasser l'mulation des fichiers 0, 1, 2 comme fichiers d'entre standard, de sortie standard, et d'erreur standard. Ainsi, file.o ne dpend plus de console.o


// Gestion de fichier
#include "../include/file.h"

#ifndef STRICT
#include "../include/console.h"
#endif


// Permet de monter ou dmonter la disquette
int mount(int mnt)
{
#ifdef FAKE
  fakemount(mnt);
#else
  sys_mount(mnt);
#endif
}

// Ouvre un fichier
int openf(char * file)
{
#ifdef FAKE
  fakeopenf(file);
  return 0;
#else
  sys_open(file);
#endif
}

// Lit au plus nb octets  partir de la position courante
int readf(int fd, char * data, int nb)
{
#ifdef FAKE
  fakereadf(fd, data, nb);
#else
  sys_read(fd, data, nb);
#endif
}

// Ecrit nb octets  partir de la position courante
int writef(int fd, char * data, int nb)
{
#ifdef FAKE
  //fakewritef(fd, data, nb);
#else
#ifndef STRICT
  if(fd == 1) // Sortie standard
    {
      int i;
      for(i=0; i < nb; i++) sys_putchar(data[i]);
    }
#endif
  sys_write(fd, data, nb);
#endif
}

// Dplace le fichier
int seek(int fd, int depl, int mode)
{
#ifdef FAKE
  return 0;
#else
  sys_seek(fd, depl, mode);
#endif
}

// Ferme le fichier
int closef(int fd)
{
#ifdef FAKE
  fakeclosef(fd);
#else
  sys_close(fd);
#endif
}

// Cr un pipe
int pipe(int uid)
{
#ifdef FAKE
  return 0;
#else
  sys_pipe(uid);
#endif
}


