// MemProcess.h
// Gestion de la mmoire lors de la cration d'un process




// Cette structure contient toutes les informations relatives  la cration d'un process
// Elle est dcompose en 2 parties: la partie in qui contient les informations  donner,
// et la partie out, qui contient les informations indiques par la structure.

typedef struct MemProc
{
  struct ProcIn
  {
    int NumProcess; // Le numro du process que l'on va crer
    int NbCodePage; // Le nombre de pages  rserver pour le code
    void * CodeEntry; // L'adresse virtuelle o implanter les pages de code
    int NbDataPages; // Le nombre de pages  rserver pour les data
    void * DataEntry; // L'adresse virtuelle o implanter les data
    int NbStackPages; // Le nombre de pages  rserver pour la pile
    void * StackEntry; // L'adresse virtuelle o implanter la pile. Attention: la pile va vers le bas. C'est donc l'adressse suprieure
  } In;


  struct ProcOut
  {
    void * CodeEntry; // Adresse virtuelle du code dans l'espace kernel
    void * DataEntry; // Adresse virtuelle du data dans l'espace kernel
    void * StackEntry; // Adresse virtuelle du stack dans l'espace kernel
    unsigned long cr3; // cr3 du process
  } Out;
} MemProc;


// Cette fonction prend une structure MemProc en paramtre. Elle cr les zones mmoires demandes dans In, et les mappe dans
// l'espace kernel aux adresses indiques dans Out. Ainsi, le kernel peut copier le code, les donnes et la pile.
int CreateMemProcess(MemProc * memProc);

// 0 -> Tout va bien
// < 0 -> Certaines pages n'ont pas t libres
int NettoieKernel(MemProc * memProc);
