#ifndef PROCESS_H
#define PROCESS_H

#include<sched.h>
#include<fichier.h>

struct semaphore
{
    int mutex;
    int sid;
};

struct tss
{
    int ret;
    int esp0;
    short ss0;
    short dummy0;
    int esp1;
    short ss1;
    short dummy1;
    int esp2;
    short ss2;
    short dummy2;
    int reserved;
    int eip;
    int eflags;
    int eax;
    int ecx;
    int edx;
    int ebx;
    int esp;
    int ebp;
    int esi;
    int edi;
    short es;
    short dummy4;
    short cs;
    short dummy5;
    short ss;
    short dummy6;
    short ds;
    short dummy7;
    short fs;
    short dummy8;
    short gs;
    short dummy9;
    short gdt;
    short dummy10;
    short T;
    short carteES;
};




struct TSS
{
    short limite;
    short base1;
    char base2;
    unsigned p:1;
    unsigned dpl:2;
    unsigned dt:1;
    unsigned type:4;
    unsigned g:1;
    unsigned zero:2;
    unsigned avl:1;
    unsigned limite2:4;
    char base3;
};

struct process_context
{
    int ebx;
    int ecx;
    int edx;
    int cr3;
    int eax;
    int edi;
    int esi;
    int ebp;
    int gs;
    int fs;
    int es;
    int ds;
    int eip;
    int cs;
    int eflags;
    int esp;
    int ss;
};
                           

struct process
{
    int pid;
    int uid;
    int priority;
    struct process_context * context;
    struct process * prev;
    struct process * suiv;
    int state;
    unsigned long time;
    long ttl;
    unsigned long tts;
    int console;
    void * meminfo;
    struct fichier * fichier[NB_FICHIER];
    int semaphore;
};

#define RUNNING 0
#define STOPPED 1
#define SLEEPING 2
#define SYSTEM 3
#define MORT 4

extern int * pilesys;
extern struct tss * tss_systeme ;
extern struct process _init;
extern struct process * current;
extern struct process * init;
extern volatile unsigned long jiffies;

#endif
