.org 0
zero:
jmp start

.org 0x3e
chaine:
.ascii "BABO loading"
.byte 0,0
SEGBARBUX = 0x1000
SEGBOOT = 0x07c0
BARBUXSIZE = 3000
SEGFIN  = SEGBARBUX + BARBUXSIZE
sectors = 18



start:
   
    mov ax, #SEGBOOT
    mov ds, ax
    mov ax, #chaine
    call print
   
    mov ax, #SEGBARBUX     ; on charge barbux en 0x10000
    mov es,ax
    call read_barbux
    call kill_motor

    
    
eend:   
    jmpi zero,SEGBARBUX

   
ennd:
jmp ennd



print:
    push ax
    push si
    push bx
    mov si, ax
bcl:
    cmpb [si],#0
    je fin
    mov ah,#0x0e
    mov al, [si]
    mov bl, #0
    int #0x10
    inc si
    jmp bcl

fin:

    pop bx
    pop si
    pop ax
    ret

dot:
    mov ah,#0x0e
    mov al,#0x2e
    mov bl, #0
    int #0x10
    ret

; cette procedure stoppe le lecteur de disquette
kill_motor:
    push dx
    mov dx,#0x3f2
    mov al,#0
    outb 
    pop dx
    ret


sread:	.word 1		; sectors read of current track
head:	.word 0			; current head
track:	.word 0			; current track
read_barbux:
	mov ax,es
	test ax,#0x0fff
die:	jne die			; es must be at 64kB boundary
	xor bx,bx		; bx is starting address within segment
rp_read:
	mov ax,es
	cmp ax,#SEGFIN		; have we loaded all yet?
	jb ok1_read
	ret
ok1_read:
	mov ax,#sectors
	sub ax,sread
	mov cx,ax
	shl cx,#9
	add cx,bx
	jnc ok2_read
	je ok2_read
	xor ax,ax
	sub ax,bx
	shr ax,#9
ok2_read:
	call read_track
	mov cx,ax
	add ax,sread
	cmp ax,#sectors
	jne ok3_read
	mov ax,#1
	sub ax,head
	jne ok4_read
	inc track
ok4_read:
	mov head,ax
	xor ax,ax
ok3_read:
	mov sread,ax
	shl cx,#9
	add bx,cx
	jnc rp_read
	mov ax,es
	add ax,#0x1000
	mov es,ax
	xor bx,bx
	jmp rp_read

read_track:
	push ax
	push bx
	push cx
	push dx
	mov dx,track
	mov cx,sread
	inc cx
	mov ch,dl
	mov dx,head
	mov dh,dl
	mov dl,#0
	and dx,#0x0100
	mov ah,#2
	int 0x13
	call dot
	jc bad_rt
	pop dx
	pop cx
	pop bx
	pop ax
	ret
bad_rt:	mov ax,#0
	mov dx,#0
	int 0x13
	pop dx
	pop cx
	pop bx
	pop ax
	jmp read_track

.org 0x1be
.word 0x0080,0x0001,0x0101,0x4f12,0,0,0x0b40


.org 510
.word 0xAA55
