#include<io.h>
#include<process.h>
#include <stdio.h>
#include <barbux.h>

void clavier();

static int ctrl,alt,shift;

static char min[128]=
    {   /*0-19*/  0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,0,'a','z','e','r',
	/*20-39*/ 't','y','u','i','o','p',0,0,'\n',0,'q','s','d','f','g','h','j','k','l','m',
	/*40-59*/ 0,0,0,0,'w','x','c','v','b','n',0,0,0,0,0,0,0,' ',0,0,
	/*60-79*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*80-99*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*100-119*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*120-127*/ 0,0,0,0,0,0,0,0 };

static char maj[128]=
    {   /*0-19*/  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'A','Z','E','R',
	/*20-39*/ 'T','Y','U','I','O','P',0,0,'\n',0,'Q','S','D','F','G','H','J','K','L','M',
	/*40-59*/ 0,0,0,0,'W','X','C','V','B','N',0,0,0,0,0,0,0,' ',0,0,
	/*60-79*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*80-99*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*100-119*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*120-127*/ 0,0,0,0,0,0,0,0 };

static char altg[128]=
    {   /*0-19*/  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*20-39*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*40-59*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*60-79*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*80-99*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*100-119*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	/*120-127*/ 0,0,0,0,0,0,0,0 };

void init_clavier()
{
    add_idt(0x21,&clavier);
    outb(inb_p(0x21)&~0x02,0x21);
    ctrl = 0;
    alt = 0;
    shift = 0;
    printk("Clavier initialise\n");
}

static char scan_to_ascii(char a)
{
    unsigned char ua = (unsigned char) a;
    int make = !(((ua & 0x80)>>7)==1);
    ua&=0x7f;
   
//    printk(" scan_to_ascii %d ",a);
    if(!shift && !ctrl && !alt && make)
    {
	return(min[ua]);
    }
    if(shift && !ctrl && !alt && make)
    {
	return(maj[ua]);
    }
    return -1;

}

int special(char a)
{
    unsigned char ua = (unsigned char) a;
    int make = !(((ua & 0x80)>>7)==1);
    ua&=0x7f;
    switch (ua)
    {
	case 29:
	    ctrl = make;
	    break;
	case 42:
    shift = make;
	    break;
	case 56:
	    alt = make;
	    break;
	default:
	    return 0;
    }
    return 1;
}
    
static struct process * asker = NULL;

void wait_for_clavier(struct process * ask)
{
    set_pending(ask->console,ask);
}
void do_clavier()
{
    char a,ascii;
    int i = get_current_console();
    a=in(0x60);
    
    if(!special(a))
    {
	ascii = scan_to_ascii(a);
	if(ascii!=-1)
	{
	    if(putchar_clavier(ascii,i)==-1)
		printk("buffer de %d plein\n",i);
	    if (is_pending(i))
	    {
		struct process * pend=get_pending(i);
		pend->state=SYSTEM;
		set_pending(i,NULL);
	    }
    
	}
    }
    out(0x20,0x20);
}

