#include<bstdarg.h>
#include <process.h>
#include <stdio.h>
#define BUFFER_SIZE 10

typedef struct console
{
    int x;
    int y;
    char * video;
    char * couleur;
    struct console * prev;
    struct console * suiv;
    int numero;
    char buffer_clavier[BUFFER_SIZE];
    int touche_in_buffer;
    int pos_lire;
    int pos_ecrire;
    int wait;
    char current_couleur;
    struct process * pending;
    int owner;
} console;

console * Console;
console * derniere_console_utilisee;
static int current_console;

static console * get_console(int i);

int set_owner(int i,int pid)
{
    console * c;
    c=get_console(i);
    if (c==NULL) return -1;
    c->owner = pid;
    return 0;
}

int get_owner(int i)
{
    console * c;
    c=get_console(i);
    
    if (c==NULL) return -1;
	    
    return c->owner;
}

int is_pending(int i)
{
    console * c;
    c=get_console(i);
    if (c==NULL) return -1;
	    
    return (c->pending != NULL);
}

struct process * get_pending(int i)
{
    console * c;
    c=get_console(i);
    if (c==NULL) return NULL;
    return (c->pending);
}

int set_pending(int i,struct process * pend)
{
    console * c;
    c=get_console(i);
    if (c==NULL) return -1;
    c->pending=pend;
    return 0;
}

char getchar_clavier(int i)
{
    console * c;
    char buf;
    c=get_console(i);
    if (c->touche_in_buffer==0)
    {
//	printk( "getchar %d ",-1);
	return -1;
    }
    buf=c->buffer_clavier[c->pos_lire];
    c->pos_lire++;
    if(c->pos_lire==BUFFER_SIZE) c->pos_lire = 0;
    c->touche_in_buffer--;
  //  printk( "getchar %d ",buf);
    return buf;
}

int putchar_clavier(char car,int i)
{
    console * c;
    c=get_console(i);
    //printk(" putchar %d ",car);
    if (c->touche_in_buffer==BUFFER_SIZE)
    {
        return -1;
    }
    c->buffer_clavier[c->pos_ecrire]=car;
    c->pos_ecrire++;
    if(c->pos_ecrire==BUFFER_SIZE) c->pos_ecrire = 0;
    c->touche_in_buffer++;
    return 0;
}

int get_current_console()
{
    return current_console;
}

void set_current_console(int i)
{
    console * c;
    current_console=i;
    c=get_console(i);
    flush_console(c);
}

void init_console()
{
    Console = (console*)kalloc(sizeof(console));
    Console->x=1;
    Console->y=1;
    Console->video=(char*)kalloc(2000);
    Console->couleur=(char*)kalloc(2000);
    Console->prev=Console;
    Console->suiv=Console;
    Console->numero=0;
    derniere_console_utilisee=Console;
    set_current_console(0);
    Console->current_couleur = 0x07;
    Console->wait=0;
    clear_console(0);
    Console->touche_in_buffer=0;
    Console->pos_lire=0;
    Console->pos_ecrire=0;
    Console->pending=NULL;
}

static int get_first_libre(console ** prevnew)
{
    console * c;
    int i=1;
    c=Console;
    c=c->suiv;
    while(i==(c->numero))
    {
	i++;
	c=c->suiv;
    }
    (*prevnew)=c->prev;
    return i;
}
	

int add_console()
{
    int i;
    console * curr;
    console * prev;
    console * suiv;
    i=get_first_libre(&prev);
    suiv=prev->suiv;
    curr=(console*)kalloc(sizeof(console));
    curr->x=1;
    curr->y=1;
    curr->current_couleur = 0x07;
    curr->touche_in_buffer=0;
    curr->pos_lire=0;
    curr->pos_ecrire=0;
    curr->video=(char*)kalloc(2000);
    curr->couleur=(char*)kalloc(2000);
    curr->prev=prev;
    curr->suiv=suiv;
    curr->numero=i;
    curr->wait = 0;
    curr->pending = NULL;
    prev->suiv=curr;
    suiv->prev=curr;
    return i;
}


static console * get_console(int i)
{
    console * c = Console;
    if ((derniere_console_utilisee->numero)==i) return derniere_console_utilisee;
    if (i==0) return Console;
    c=c->suiv;
    while ((c->numero)!=0)
    {
	if ((c->numero)==i) return c;
	c=c->suiv;
    }
    return 0;
}
    

int del_console(int i)
{
    console * c;
    if (i==0) return -1;
    c=get_console(i);
    if (c==0) return -1;
    kfree(c->video);
    kfree(c->couleur);
    (c->prev->suiv)=c->suiv;
    (c->suiv->prev)=c->prev;
    if (derniere_console_utilisee==c) derniere_console_utilisee = c->suiv;
    kfree(c);
    return 0;
}

int clear_console(int i)
{
    console * c;
    int j;
    char coul;
    c=get_console(i);
    coul=c->current_couleur;
    if (c==0) return -1;
    derniere_console_utilisee = c;
    for(j=0;j<2000;j++)
    {
	c->video[j]=' ';
	c->couleur[j] = coul;
    }
    c->x=1;
    c->y=1;
    if (c->numero==get_current_console()) flush_console(c);
    return 0;
}

int get_console_xy(int i,int *x,int *y)
{
    console * c;
    c=get_console(i);
    if (c==0) return -1;
    derniere_console_utilisee = c;
    *x=c->x;*y=c->y;
    return 0;
}
    

	
int set_console_xy(int i,int x,int y)
{
    console * c;
    c=get_console(i);
    if (c==0) return -1;
    derniere_console_utilisee = c;
    c->x=x;
    c->y=y;
    return 0;
}

void decale(console * c)
{
    int i;
    for(i=0;i<1920;i++)
    {
	c->video[i]=c->video[i+80];
	c->couleur[i]=c->couleur[i+80];
    }
    for(i=1920;i<2000;i++)
    {
	c->video[i]=' ';
	c->couleur[i]=c->current_couleur;
    }
    if (c->numero==get_current_console()) flush_console(c);
}

int flush_console(console * c)
{
    copy2video(c->video,c->couleur);
    return(0);
}

//extern char * video;

int _putchar(console * c, char ch,int j)
{
    int i;
    i=(c->y-1)*80+(c->x-1);
    c->video[i]=ch;
    c->couleur[i]=c->current_couleur;
    if (j==get_current_console()) 
    {
	printxy(ch,c->x-1,c->y-1,c->current_couleur);
	cursorxy(c->x+1,c->y);
    }
}

int putchar(int i,char ch)
{
    console * c;
    c=get_console(i);
    if (c==0) return -1;
    derniere_console_utilisee = c;
    
    if(c->wait!=0)
	switch(c->wait)
	{
	    case 1:
	    {
		c->current_couleur=ch;
		c->wait = 0;
		return 1;
	    }
	    default:
	    return -1;
	}
		
	    
    
    switch(ch)
    {
	case '\n':
	{
	    if((c->y)<25) (c->y)++;
	    else decale(c);
	    c->x=1;
	    return 1;
	}
	case 127:
	{
	    if ((c->x)<80) (c->x)--;
	    _putchar(c,' ',i);
	    return 1;
	}
	case 27:
	{
	    c->current_couleur=ch;
	    c->wait = 1;
	    return 1;
	}
	
	default:
	{
	
	    _putchar(c,ch,i);
	    if((c->x)<80) (c->x)++;
	    else
	    {
	        if((c->y)<25) (c->y)++;
		else decale(c);
		c->x=1;
	    }
	    
	    return 1;
	}
    }
    return 0;
}

int text(int i,char* a)
{
    char * b;
    b=a;
    while(*b!=0)
    {
	if(putchar(i,*b)==-1) return -1;
	b+=1;
    }
    return 0;
}

static char buf[512];

int printk(const char *fmt, ...)
{

    va_list args;
    int i;

    va_start(args, fmt);
    i = vsprintf(buf, fmt, args);
    va_end(args);

    text(get_current_console(),buf);
    return i;
}

