.text
.globl stext,idt,add_idt,testtimer,add_idt_user

stext:

    cld
    cli

    mov $0x18,%eax   	# Mise en place des segments donnee et pile
    mov %ax,%ds		#
    mov %ax,%es		#
    mov %ax,%fs		#
    mov %ax,%gs		#
    mov %ax,%ss		#
    
    mov $0x50000,%eax   # Mise en place de la pile kernel en 0x50000
    mov %eax,%esp	#
    mov %eax,%ebp	#
    
    xorl %eax,%eax      # test de la porte A20
1:  incl %eax		#
    movl %eax,0x000000	#
    cmpl %eax,0x100000	#
    je 1b 		#
    
     
    call setupaging 	# mise en place de la pagination 
    
    call gere_idt	# mise en place d une idt
    lidt idt_descr	#
    
    
#    movl $divide_zero,%eax
#    pushl %eax
#    xorl %eax,%eax
#    pushl %eax
#//    call add_idt
#    popl %eax
#    popl %eax
    
    
    
    call kernelc    	# appel du kernel propement dit
    call kernel_panic	# si on quitte le kernel on cause une Kernel Panic
    
fin:			# boucle infinie si on sort du kernel panic
    jmp fin		#

setupaging:
    
    call Pagination    # mise en place de la pagination
    movl $0x1000,%eax  
    movl %eax,%cr3
    movl %cr0,%eax
    orl $0x80000000,%eax
    movl %eax,%cr0
    
    ret

pag_comme_linux:
    movl $1024*2,%ecx  
    xorl %eax,%eax
    movl $0x1000, %edi
    cld
    rep
    stosl
    movl $0x2000 + 7 , 0x1000
    movl $0x2000 +7 ,0x1000+3072
    movl $0x2000 + 4092, %edi
    movl $0x3ff007,%eax
    std
1:
    stosl
    subl $0x1000,%eax
    jge 1b
    cld
    movl $0x1000,%eax
    movl %eax,%cr3
    movl %cr0,%eax
    orl $0x80000000,%eax
    movl %eax,%cr0
    ret

add_idt:
    pushl %ebp
    movl %esp,%ebp
    pushl %ebp
    movl 12(%ebp),%edx
    movl 8(%ebp),%ecx

    movl $(0x10 << 16),%eax
    movw %dx,%ax 
//    movw $0x8E00,%dx
    movw $0xEE00,%dx
    
    lea idt,%edi
    shl $3,%ecx
    addl %ecx,%edi
    movl %eax,(%edi)
    movl %edx,4(%edi)
    
pas_add_idt:
    popl %ebx
    movl %ebp,%esp
    popl %ebp

    ret

add_idt_user:
    pushl %ebp
    movl %esp,%ebp
    pushl %ebp
    movl 12(%ebp),%edx
    movl 8(%ebp),%ecx
 
    movl $(0x10 << 16),%eax
    movw %dx,%ax 
    movw $0xEE00,%dx
    
    lea idt,%edi
    shl $3,%ecx
    addl %ecx,%edi
    movl %eax,(%edi)
    movl %edx,4(%edi)
    
    popl %ebx
    movl %ebp,%esp
    popl %ebp

    ret

   



gere_idt:
    lea ignore_int,%edx
    movl $(0x10 << 16),%eax
    movw %dx,%ax            /* selector = 0x0010 = cs */
    movw $0x8E00,%dx        /* interrupt gate - dpl=0, present */

    lea idt,%edi
    mov $256,%ecx
rp_sidt:
    movl %eax,(%edi)
    movl %edx,4(%edi)
    addl $8,%edi
    dec %ecx
    jne rp_sidt
    ret
	
int_msg:
    .asciz "Unknown interrupt\n"
    .word 0
	

.align 2
ignore_int:
    mov $0x20,%al
    outb %al,$0x20
    iret
    cld
    pushl %eax
    pushl %ecx
    pushl %edx
    push %ds
    push %es
    push %fs
    movl $0x18,%eax
    mov %ax,%ds
    mov %ax,%es
    mov %ax,%fs
    mov $0x1000,%eax
    mov %eax,%cr3
    pushl $int_msg
    call printk
mlop: jmp mlop
    popl %eax
    pop %fs
    pop %es
    pop %ds
    popl %edx
    popl %ecx
    popl %eax
    iret



// The interrupt descriptor table has room for 256 idt's
 
.align 4
.word 0
idt_descr:
    .word 256*8-1           # idt contains 256 entries
    .long idt

.align 4
idt:
    .fill 256,8,0           # idt is uninitialized
    .align 4
    .word 0

.align 2


testtimer:
    push %ds                # save ds,es and put kernel data space
    push %es                # into them. %fs is used by _system_call
    push %fs
    pushl %edx              # we save %eax,%ecx,%edx as gcc doesnt
    pushl %ecx              # save those across function calls. %ebx
    pushl %ebx              # is saved as we use that in ret_sys_call
    pushl %eax
    movl $0x10,%eax
    mov %ax,%ds
    mov %ax,%es
    movl $0x17,%eax
    mov %ax,%fs
    incl jiffies
    movb $0x20,%al          # EOI to interrupt controller #1
    outb %al,$0x20
    movl 0x20(%esp),%eax
    andl $3,%eax            # %eax is CPL (0 or 3, 0=supervisor)
    pushl %eax
    call switch_task        # do_timer(long CPL) does everything from
    addl $4,%esp            # task switching to accounting ...
    jmp ret_from_sys_call


ret_from_sys_call:

    popl %eax
    popl %ebx
    popl %ecx
    popl %edx
    pop %fs
    pop %es
    pop %ds
    iret
