#include <process.h>

#define _set_gate(gate_addr,type,dpl,addr) \
__asm__ __volatile__ ("movw %%dx,%%ax\n\t" \
    "movw %2,%%dx\n\t" \
    "movl %%eax,%0\n\t" \
    "movl %%edx,%1" \
    :"=m" (*((long *) (gate_addr))), \
     "=m" (*(1+(long *) (gate_addr))) \
    :"i" ((short) (0x8000+(dpl<<13)+(type<<8))), \
     "d" ((char *) (addr)),"a" (0x10 << 16) \
    :"ebx","ecx")

#define set_intr_gate(n,addr) \
        _set_gate(&idt[n],14,0,addr)

#define set_trap_gate(n,addr) \
        _set_gate(&idt[n],15,0,addr)

#define set_system_gate(n,addr) \
        _set_gate(&idt[n],15,3,addr)

#define set_call_gate(a,addr) \
        _set_gate(a,12,3,addr)
    
typedef struct desc_struct {
            unsigned long a,b;
} desc_table[256];

    
extern desc_table idt;

struct task_gate
{
    short reserved;
    short tss;
    char reserverd2;
    unsigned type:5;
    unsigned dpl:2;
    unsigned p:1;
    short reserved3;
};

struct interrupt_gate
{
    short offset1;
    short segment;
    unsigned reserved:5;
    unsigned type:3;
    unsigned type2:3;
    unsigned d:1;
    unsigned type3:1;
    unsigned dpl:2;
    unsigned p:1;
    short offset2;
};

struct trap_gate
{
    short offset1;
    short segment;
    unsigned reserved:5;
    unsigned type:3;
    unsigned type2:3;
    unsigned d:1;
    unsigned type3:1;
    unsigned dpl:2;
    unsigned p:1;
    short offset2;
};


struct locate_idt
{
    short limite;
    int base;
};

void init_task_gate(struct task_gate * gate)
{
    gate->type=0x5;
}

void init_interrupt_gate(struct interrupt_gate * gate)
{
    gate->type=0x0;
    gate->type2=0x6;
    gate->type3=0;
}
    
void init_trap_gate(struct interrupt_gate * gate)
{
    gate->type=0x0;
    gate->type2=0x7;
    gate->type3=0;
}



//struct interrupt_gate idt[4];

void divide_zero()
{
    panic("Division par zero");
    __asm__("iret");
}

void double_fault()
{
    get_system_cr3();
    panic("Double faute");
}

void seg_fault()
{
    panic("Segmentation Fault");
}

void protec_faute()
{
    panic("Erreur de protection generale");
}

void debug_exception()
{
    panic("Debug Exception");
}

void NMI_Interrupt()
{
    panic("NMI Interrupt");
}

void Breakpoint_Exception()
{
    panic("Breakpoint Exception");
}

void Overflow_Exception()
{
    panic("Overflow Exception");
}

void Range_Exceeded()
{
    panic("Range Exceeded");
}

void Invalid_Opcode(struct process_context ebb)
{
    char * a;
    affiche_process(&ebb);
    a=(char*) ebb.eip;
    printk("%x %x %x %x %x %x %x %x %x %x\n",a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9]);
    panic("Invalid Opcode");
}

void Device_Not_Available()
{
    panic("Device Not Available");
}

void Segment_Overrun()
{
    panic("Segment Overrun");
}

void Invalid_TSS()
{
    panic("Invalid TSS");
}

void Segment_Not_Present()
{
    panic("Segment Not Present");
}

void Stack_Fault()
{
    panic("Stack Fault");
}

void Floating_Point_Error()
{
    panic("Floating-Point Error");
}

void asm_invalid_opcode(void);
void system_call(void);
void add_idt(int , void(*)(void));
void add_idt_user(int , void(*)(void));

static char * video = (char) 0xb8000;

void appel_test()
{
    __asm__ ("mov 0x666,%%ecx":);
    get_system_cr3();
    out(0x20,0x20);
    video[0]='B'; 
    //printk("coucou");
    get_user_cr3();
    __asm__("iret");
}

void clavier(void);

void init_interrupt()
{
    int i;
    short a,b;
    int ptr;
    struct locate_idt loc;
    printk("Initialisation des interruptions\n");
    
    add_idt(0,&divide_zero);
    add_idt(1,&debug_exception);
    add_idt(2,&NMI_Interrupt);
    add_idt(3,&Breakpoint_Exception); 
    add_idt(4,&Overflow_Exception);
    add_idt(5,&Range_Exceeded);
    add_idt(6,&asm_invalid_opcode);
    add_idt(7,&Device_Not_Available);
    add_idt(8,&double_fault);
    add_idt(9,&Segment_Overrun);
    add_idt(10,&Invalid_TSS);
    add_idt(11,&Segment_Not_Present); 
    add_idt(12,&Stack_Fault); 
    add_idt(13, &protec_faute);
    add_idt(14, &seg_fault);
    add_idt(16,&Floating_Point_Error);
    add_idt_user(0x69,&system_call);
    add_idt_user(0x68,&appel_test);
    __asm__("sti");
}

