// memprocess.c
#include <memprocess.h>
#include <process.h>

int CreateMemProcess(MemProc * memProc)
{
  int i;
  unsigned int e;
  int NumProcess = memProc->In.NumProcess;
  unsigned int * p;
  // On commence par crer pgtable et ttpage
  // pg_table
  memProc->Out.cr3=kpage_alloc(((unsigned int)(NumProcess-100)*0x2000+0x100000), 0);

  // ttpage
  current->meminfo = kpage_alloc(((unsigned int)(NumProcess-100)*0x2000+0x101000), 0);
  e = 0xc0000000;
  
  // On enregistre la zone de code
  memProc->Out.CodeEntry = (void *)e;

  // On implante les pages de code, et on les partage
  for(i = 0; i < memProc->In.NbCodePage; i++)
    {
      int m = kpage_alloc(memProc->In.CodeEntry + i*0x1000, NumProcess);
      kpage_partage(e, 0, m);
      e += 0x1000;
    }
  // On enregistre la zone de data
  memProc->Out.DataEntry = (void *)e;

  // On implante les pages de data, et on les partage
  for(i = 0; i < memProc->In.NbDataPages; i++)
    {
      int m = kpage_alloc(memProc->In.DataEntry + i*0x1000, NumProcess);
      kpage_partage(e, 0, m);
      e += 0x1000;
    }

  // On implante les pages de stack, et on les partage
  for(i = 0; i < memProc->In.NbStackPages; i++)
    {
      int m = kpage_alloc(memProc->In.StackEntry + i*0x1000, NumProcess);
      kpage_partage(e, 0, m);
      e += 0x1000;
    }
  // On enregistre la zone de stack
  memProc->Out.StackEntry = (void *)(e - 0x1);

  // On mappe le premier mga du kernel
  for(i=0; i < 1024/4; i++)
    {
      kpage_partage(i*0x1000, NumProcess, i*0x1000);
    }
}

int NettoieKernel(MemProc * memProc)
{
  int i;
  int err = 0;
  // On libre les pages de code
  for(i = 0; i < memProc->In.NbDataPages; i++)
    {
      err += kpartage_free(memProc->Out.DataEntry + i*0x1000, 0);
    }
  // On libre les pages de data
  for(i = 0; i < memProc->In.NbDataPages; i++)
    {
      err += kpartage_free(memProc->Out.DataEntry + i*0x1000, 0);
    }
  // On libre les pages de stack
  for(i = 0; i < memProc->In.NbStackPages; i++)
    {
      err += kpartage_free(memProc->Out.StackEntry - i*0x1000, 0);
    }
  return err;
}

