#include <io.h>
#include <process.h>
#include <memprocess.h>
#include <stdio.h>
#define LATCH (1193180/HZ)

int _pilesys[1024];
int * pilesys;
int piletss[1024];

struct tss * tss_systeme ;

struct process _init;
struct process_context _init_context;

volatile unsigned long jiffies=0;
struct process * current;
struct process * init;
void relatch();

int reschedule = 0;
int resystem = 0;

inline void get_system_cr3()
{
    __asm__("movl $0x1000,%%eax ;" " movl %%eax,%%cr3":);
}

inline void get_user_cr3()
{
    __asm__("movl %0,%%eax ;" "movl %%eax,%%cr3" : "=m" (current->context->cr3));
}

inline void get_cr3(unsigned long cr3)
{
        __asm__("movl %0,%%eax ;" "movl %%eax,%%cr3" : "=m" (cr3));
}


int memcpy(char * dest, char * src, int nb)
{
    int i;
    for(i=0;i<nb;i++)
    {
	dest[i]=src[i];
    }
    return i;
}

void affiche_process(struct process_context *p)
{
    printk("eax 0x%x ebx 0x%x ecx 0x%x edx 0x%x\n",p->eax,p->ebx,p->ecx,p->edx);
    printk("esi 0x%x edi 0x%x esp 0x%x eip 0x%x\n",p->esi,p->edi,p->esp,p->eip);
    printk("ebp 0x%x cr3 0x%x cs 0x%x ss 0x%x\n",p->ebp,p->cr3,p->cs,p->ss);
    printk("ds 0x%x es 0x%x fs 0x%x gs 0x%x\n",p->ds,p->es,p->fs,p->gs);
}


int get_free_kernel_process(struct process **av)
{
    struct process * p = init;
    int i=1;
    p=p->suiv;
    while(1)
    {
	if(i!=p->pid)
	{
	    *av=p;
	    return i;
	}
	i++;
	if ((p->pid)==100) return -1;   // plus de place pour un process kernel
	p=p->suiv;
    }
}

int get_free_user_process(struct process **av)
{
    struct process * p = init;  
    int i=100;
    p=p->suiv;
    while(p->pid<100 && p->pid!=0) p=p->suiv;
    while(1)
    {
	if(i!=p->pid)
	{
	    *av=p;
	    return i;
	}
	i++;
	p=p->suiv;
    }
}

struct process * get_process(int i)
{
    struct process * p = init;
    p=p->suiv;
    while(p!=init)
    {
	if (p->pid==i) return p;
	p=p->suiv;
    }
    return NULL;
}

struct process * create_process(int kernel)
{
    int i;
    struct process * tmp;
    struct process * av;
    if (kernel==1) i=get_free_kernel_process(&av);
    else i=get_free_user_process(&av);
    if(i==-1) return NULL;
    tmp = (struct process *)kalloc(sizeof(struct process));
//    printk("j'ai demande %d et j'ai recu %x\n",sizeof(struct process),tmp);
    memcpy((char*)tmp,(char*)current,sizeof(struct process));
    tmp->pid=i;
    tmp->time=0;
    tmp->context=(struct process_context *)kalloc(sizeof(struct process_context));
//    printk("j'ai demande %d et j'ai recu %x\n",sizeof(struct process_context),tmp->context);
    memcpy((char*)tmp->context,(char*)current->context,sizeof(struct process_context));
    tmp->suiv=av;
    tmp->prev=av->prev;
    av->prev=tmp;
    tmp->prev->suiv=tmp;
//    printk("creation de %d %x %x %x\n",i,tmp->prev,tmp,tmp->suiv);
    return tmp;
}
    
int delete_process(int i)
{
    struct process * tmp;
    tmp = get_process(i);
    tmp->prev->suiv=tmp->suiv;
    tmp->suiv->prev=tmp->prev;
    detruire_fichier(tmp->fichier);
    kfree(tmp->context);
    kfree(tmp);
    return 0;
}

void schedule(struct process_context * old)
{
    struct process * p;
    current->time++;
    current->ttl--;
    if (current->ttl<=0)
    {
	p=current->suiv;
	while(p->state!=RUNNING && p->state !=SYSTEM) 
	{
	    if(p->state==SLEEPING)
	    {
		if (p->tts <= jiffies) 
		{
		    p->state=RUNNING;
		    break;
		}
	    }
	    if(p->state == MORT)
	    {
		struct process * p2=p->suiv;
		delete_process(p->pid);
		p=p2;
		continue;
	    }
	    p=p->suiv;
	}
	
	if (p->state==SYSTEM)
	{
	    p->state = RUNNING;
	    resystem = 1;
	}
	
	p->ttl=p->priority;
	memcpy((char*)current->context,(char*)old,sizeof(struct process_context));
	memcpy((char*)old,(char*)p->context,sizeof(struct process_context));
	
//	affiche_process(p->context);
//      printk("Switch !!! %d -> %d time = %d jiffies = %d\n",current->pid,p->pid,current->time,jiffies);
	current=p;
    }
}

void do_switch_task(struct process_context ebx)
{
    outb_p(0x20,0x20);
    schedule(&ebx);
  /* if(jiffies == 200)
   {
       __asm__("cli");
       while(1);
   }*/
    
    
/*    get_console_xy(0,&x,&y);
    set_console_xy(0,40,10);    
    printk("jiffies %d",jiffies);
    set_console_xy(0,x,y);*/
//    __asm__("sti");
}

void switch_task();
void switch_task_2();

void testtimer();

static void init_timer()
{
    outb_p(0x36,0x43);
    outb_p(LATCH & 0xff,0x40);
    outb(LATCH >> 8,0x40);
}

static void init_tss()
{
    
    tss_systeme = (struct tss *) 0x10000;
    tss_systeme->esp0=0x80000;//((int)&piletss[0])+4092;
    tss_systeme->ss0=0x18;
    __asm__("movw $0x30,%ax ; ltr %ax;");
    
}

void create_init()
{
    init=&_init;
    init->context=&_init_context;
    current=init;
    init->uid=0;
    init->pid=0;
    init->priority=20;
    init->time=0;
    init->ttl=1;
    init->semaphore=0;
    init->state=RUNNING;
    init->prev=init;
    init->suiv=init;
    create_fichier(init->fichier);    
}

int kernel_thread(void(*func)(void), void * pile)
{
    struct process * p;
    outb(inb_p(0x21)|0x01,0x21); // pas de timer pendant un kernel_thread
//    printk("entre dans create_process");
    p=create_process(1);
//    printk("process %d : %x\n",p->pid,p);
//     printk("sortie de create_process");
    p->context->eip=(int)func;
    p->context->esp=(int)pile;
    p->context->ss=0x18;
    p->context->ds=0x18;
    p->context->es=0x18;
    p->context->fs=0x18;
    p->context->gs=0x18;
    p->context->cs=0x10;
    
    p->semaphore = 0;
    p->priority=3;
    create_fichier(init->fichier);    
    outb(inb_p(0x21)&~0x01,0x21); // c bon, on peut autoriser le timer
    return p->pid;
}

int user_process(void * prog , int taille)
{
    struct process * p;
    struct MemProc M;
    unsigned int * po;
    unsigned int * r;
    struct process * save_current;
    char  * a;

    outb(inb_p(0x21)|0x01,0x21); // pas de timer pendant un kernel_thread

    
    
    p=create_process(0);
    
    p->state=STOPPED;

    M.In.NumProcess=p->pid;
    M.In.NbCodePage=10;
    M.In.CodeEntry=(void*)0x1000000;
    M.In.NbDataPages=0;
    M.In.DataEntry=(void*)0x2000000;
    M.In.NbStackPages=10;
    M.In.StackEntry=(void*)0x10000000;
    
    save_current = current;
    current = p;
    CreateMemProcess(&M);
    
    
    current = save_current;
    
    memcpy(M.Out.CodeEntry,prog,taille);
    
//    printk("process %d : %x\n",p->pid,p);
    p->context->cs=0x23;
    p->context->ss=0x2b;
    p->context->es=0x2b;
    p->context->fs=0x2b;
    p->context->ds=0x2b;
    p->context->gs=0x2b;
    p->context->cr3=M.Out.cr3;
    p->context->eip=0x1000000;
    p->context->esp=0x10009ffc; 
    p->semaphore = 0;
 
    create_fichier(init->fichier);    
    p->priority=50;
    NettoieKernel(&M);
    p->state=RUNNING;
    outb(inb_p(0x21)&~0x01,0x21); // c bon, on peut autoriser le timer
    return p->pid;
}

    
void init_scheduling()
{
    pilesys = _pilesys + 1023;
    init_tss();
    create_init();   
//    create_process();
//    create_process();
    __asm__("cli");
    init_timer();
      
    
    add_idt(0x20,&switch_task);
    add_idt(0x68,&switch_task_2);
    outb(inb_p(0x21)&~0x01,0x21);
 //   __asm__("sti");
}

void relatch()
{
    outb_p(0x36,0x43);
    outb_p(LATCH & 0xff,0x40);
    outb(LATCH >> 8,0x40);
    __asm__("sti");
}

void interruptible_sleep_on(struct process * p)
{
    p->state = STOPPED;
}

void wake_up(struct process * p)
{
    p->state = RUNNING;
}

void add_timer(long jiffies, void (*fn)(void)){};

void sleep_on(struct process **p)
{
    struct process *tmp;
    
    if (!p)
	return;
    if (current == init)
	panic("task[0] trying to sleep");
    tmp = *p;
    *p = current;
    current->state = STOPPED;
//    schedule();
    if (tmp)
	tmp->state=0;
}

void k_msleep(int msec)
{
    current->state = SLEEPING;
    current->tts = jiffies + ((msec*HZ)/1000);
    current->ttl = 0;
//    printk("Appel de ksleep %d %d %d\n",current->tts,jiffies,current->ttl);
    
    __asm__("int $0x68");
}
