#include <process.h>
#include <erreur.h>
#include <stdio.h>
#include <barbux.h>
#define SYSTEM 3
int process_en_attente;

int do_sleep(unsigned long time)
{
    unsigned long tmp;
    tmp=time;
    tmp *= HZ;
    tmp+=jiffies;
    get_system_cr3();
    current->state=SLEEPING;
    current->tts=tmp;
    current->ttl = 0;
    get_user_cr3();
    reschedule=1;
    
}

int do_usleep(unsigned long time)
{
    unsigned long tmp;
    tmp=time;
    tmp *= HZ;
    tmp /=1000;
    tmp+=jiffies;
    get_system_cr3();
    current->state=SLEEPING;
    current->tts=tmp;
    current->ttl = 0;
    get_user_cr3();
    reschedule=1;
}

int do_putchar(char ch)
{
    get_system_cr3();
    
    putchar(current->console,ch);
    
    get_user_cr3();
}

char do_getchar(int block)
{
    char a;
    get_system_cr3();
   
    a=getchar_clavier(current->console);
    if (a == -1 && block)
    {
	process_en_attente = 1;
	current->state=STOPPED;
	current->ttl = 0;
	wait_for_clavier(current);
	get_user_cr3();
	return 2; // on rexecute le getchar quand le buffer n'est plus vide
    }
    get_user_cr3();
    
    return a;
    

}

int do_geterreur(char * dest)
{
    int pid;
    
    get_system_cr3();
    pid = current->pid;
    get_user_cr3();
    
    get_erreur(dest,pid);
}

int do_console_create()
{
    int i;
    get_system_cr3();
    i=add_console();
    set_owner(i,current->uid);
    get_user_cr3();
    return i;
}

int do_console_destroy(int console)
{
    int i;
    get_system_cr3();
    if((current->uid != 0)&&(current->uid != get_owner(console))) return -1; 
    i=del_console(console);
    get_user_cr3();
    return i;
}

int do_exec(char * file,int console)
{
}

void do_exit(void)
{
    get_system_cr3();
    current->state=MORT;
    current->ttl=0;
    reschedule=1;
}

int do_kill(int pid)
{
    struct process * p;
    get_system_cr3();
    p=get_process(pid);
    if(p==NULL) return -2;
    if((current->uid !=0) && (current->uid!=p->uid)) return -1;
    p->state = MORT;
    return 0;
}

int do_getpid(void)
{
    get_system_cr3();
    return current->pid;
}

int do_getuid(void)
{
    get_system_cr3();
    return current->uid;
}

int do_setuid(int uid)
{
    get_system_cr3();
    if(current->uid != 0) return -1;
    
}

int do_addpriority(int incr)
{
    get_system_cr3();
    if (current->uid !=0 && incr <0)
    {
	return -1;
    }
    get_user_cr3();
}

int do_mount(int mount)
{
}

int do_open(char * file)
{
}

int do_read(int fd, char * dest,int nb)
{
    int i;
    get_system_cr3();
    if(fd<0 || fd > (NB_FICHIER-1)) return -2;
    if(current->fichier[fd] == NULL) return -2;
    if(current->fichier[fd]->read == NULL) return -3;
    i=current->fichier[fd]->read(dest,nb,current->fichier[fd]);
    get_user_cr3();
    return i;
}

int do_write(int fd, char * src,int nb)
{
    int i;
    get_system_cr3();
    if(fd<0 || fd > (NB_FICHIER-1)) return -2;
    if(current->fichier[fd] == NULL) return -2;
    if(current->fichier[fd]->write == NULL) return -3;
    i=current->fichier[fd]->write(src,nb,current->fichier[fd]);
    get_user_cr3();
    return i;
}

int do_seek(int fd,int deplac)
{
    int i;
    get_system_cr3();
    if(fd<0 || fd > (NB_FICHIER-1)) return -2;
    if(current->fichier[fd] == NULL) return -2;
    current->fichier[fd]->pos += deplac;
    return current->fichier[fd]->pos;
}

int do_close(int fd)
{
    int i;
    get_system_cr3();
    if(fd<0 || fd > (NB_FICHIER-1)) return -2;
    if(current->fichier[fd] == NULL) return -2;
    if(current->fichier[fd]->close == NULL) return -3;
    i=current->fichier[fd]->close(current->fichier[fd]);
    current->fichier[fd]=NULL;
    get_user_cr3();
    return i;
}

int do_pipe(int uid)
{
}

void * do_page_alloc(void * dest)
{
}

void * do_page_partage(int clef,void * dest)
{
}

int do_gettime(void)
{
    get_system_cr3();
    return ((current->time) / HZ);

}

int do_uptime(void)
{
    return(jiffies / HZ);
}

int do_P(struct semaphore * s)
{
    if((s->mutex)>0)
    {
	(s->mutex)--;
	return 0;
    }
    else
    {
	process_en_attente = 1;
	get_system_cr3();
	current->state = STOPPED;
	current->ttl = 0;
	current->semaphore = s->sid;
	return 23; 	
    }
}

int do_V(struct semaphore * s)
{
    s->mutex++;
    if(s->mutex==1)
    {
	struct process * buf = current;
	buf=buf->suiv;
	while(buf!=current)
	{
	    if (buf->state==STOPPED && buf->semaphore==s->sid )
	    {
		buf->state=SYSTEM;
		buf->semaphore=0;
	    }
	    buf=buf->suiv;
	}
    }
    return 0;
}

int do_fcntl(int fd,int cmd)
{
    get_system_cr3();
    if(fd<0 || fd > (NB_FICHIER-1)) return -2;
    if(current->fichier[fd] == NULL) return -2;
    
    if(cmd & BLOCK_FLAG)
    {
	current->fichier[fd]->block = 1;
    }
    else
    {
	current->fichier[fd]->block = 0;
    }
}

int do_nothing()
{
    return 0;
}

int do_get_free_sem()
{
    static int sem=0;
    sem++;
    return sem;
}
    
